#include "snf.h"

GLuint texture[MAX_TEXTURES];
P_TEXTURE_IMAGE tex_data[MAX_TEXTURES];

int jump_to_hyperspace_enable = FALSE;
int flashblanco = FALSE;
int flashnegro = FALSE;
int bluractive = FALSE;
int quitlogo = FALSE;
int gogos = FALSE;
int theend = FALSE;



void InitGL(GLvoid)
{    
	int i;
	for(i=0;i<MAX_TEXTURES;i++)
		tex_data[i] = AllocateTextureBuffer(256, 256);

	glEnable(GL_TEXTURE_2D);				// Enable Texture Mapping
	glShadeModel(GL_SMOOTH);				// Enables Smooth Color Shading
	glClearColor(0.0f, 0.0f, 0.0f, 0.0f);	// This Will Clear The Background Color To Black
	glClearDepth(1.0);						// Enables Clearing Of The Depth Buffer
	glEnable(GL_DEPTH_TEST);				// Enables Depth Testing
	glDepthFunc(GL_LESS);					// The Type Of Depth Test To Do

	glGenTextures(MAX_TEXTURES, texture);
	InitSilTexture();

	xtra_initefect();
}

GLvoid ReSizeGLScene(GLsizei width, GLsizei height)
{
	if (height==0)					// Prevent A Divide By Zero By
		height=1;				// Making Height Equal One

	glViewport(0,0,width,height);			// Reset The Current Viewport

	glMatrixMode(GL_PROJECTION);			// Select The Projection Matrix
	glLoadIdentity();				// Reset The Projection Matrix

	// Calculate The Aspect Ratio Of The Window
	gluPerspective(45.0f,(GLfloat)width/(GLfloat)height,0.1f,100.0f);
	glMatrixMode(GL_MODELVIEW);			// Select The Modelview Matrix
	glLoadIdentity();				// Reset The Modelview Matrix
	
	gluLookAt(0.0f,0.0f,-10.0f,0.0f,0.0f,0.0f,0.0f,1.0f,0.0f);
}


typedef struct{
	float X;
	float Y;
	float Z;
} glCoord;

glCoord Tunnels[32][32];

#define PI 3.1415926
GLvoid DrawTunnel(GLvoid)
{
	int I,J;
	static float Angle = 0.0f;
	static float TEXTURE_SPEED = 0.010f;
	float J1,J2;

	Angle += 3.0f;

	if (jump_to_hyperspace_enable){
		TEXTURE_SPEED += 0.5;
	}


	// Calculamos coordenadas para el tunel...
	for (I=0; I<=12; ++I){
		for (J=0;J<32;++J){
			Tunnels[I][J].X =(3 - J/12)*cos(2*PI/12*I) + 2*sin((Angle+2*J)/29) + cos((Angle+2*J)/13) - 2*sin(Angle/29) - cos(Angle/13);
			Tunnels[I][J].Y =(3 - J/12)*sin(2*PI/12*I) + 2*cos((Angle+2*J)/33) + sin((Angle+2*J)/17) - 2*cos(Angle/33) - sin(Angle/17);
			Tunnels[I][J].Z =-J;
		}
	}

	glLoadIdentity();								
	glTranslatef(0.0f,0.0f,-4.0f);

	xtra_calcefect(tex_data[XTRA_EFECT]);
	BuildTexture (tex_data[XTRA_EFECT], XTRA_EFECT);

	// Dibujamos el Tunel
	//  for(J=0; J<=30;++J){
	for(J=30; J>=0;--J){
		J1 = ((float)J)/32.0f  + Angle*TEXTURE_SPEED; //precalculamos coordenadas para las texturas
		J2 =((float)(J+1))/32.0f  + Angle*TEXTURE_SPEED;// Para simular velocidad...
		//    J1 = ((float)J)/32.0f; // + Angle*TEXTURE_SPEED; //precalculamos coordenadas para las texturas
		//    J2 = ((float)(J+1))/32.0f; // + Angle*TEXTURE_SPEED;// Para simular velocidad...

		//glPolygonMode(GL_FRONT_AND_BACK,GL_LINE);
		glBegin(GL_QUADS);
		for(I=0;I<=11;++I){
			glTexCoord2f(((float)(I-3))/12.0f, J1);
			//        glTexCoord2f(I/12, J1);
			glVertex3f(Tunnels[  I][   J].X, Tunnels[  I][   J].Y, Tunnels[  I][   J].Z);
			glTexCoord2f(((float)(I-2))/12.0f, J1); 
			//        glTexCoord2f(1, J1); 
			glVertex3f(Tunnels[I+1][   J].X, Tunnels[I+1][   J].Y, Tunnels[I+1][   J].Z);
			glTexCoord2f(((float)(I-2))/12.0f, J2); 
			//      glTexCoord2f(1, J2); 
			glVertex3f(Tunnels[I+1][ J+1].X, Tunnels[I+1][ J+1].Y, Tunnels[I+1][ J+1].Z);
			glTexCoord2f(((float)(I-3))/12.0f, J2); 
			//     glTexCoord2f(0, J2); 
			glVertex3f(Tunnels[  I][ J+1].X, Tunnels[  I][ J+1].Y, Tunnels[  I][ J+1].Z);
		}
		glEnd();   
	}	
}




GLvoid DrawChicaIzq(GLvoid)
{
	static int lento = 0;
	static int chicaI = 0;
	static float R  = 1;
	static float G  = 1;
	static float B  = 1;

	glLoadIdentity();								
	glTranslatef(0,0,-5.0f);
	glDisable(GL_DEPTH_TEST);

	glBindTexture(GL_TEXTURE_2D, texture[SIL1_TEXTURE+chicaI]);
	if (lento == 0){
		chicaI = (chicaI+1)%TAM_CHICA;
		R += 0.15; if (R>1) R=0;
		G += 0.08; if (G>1) G=0;
		B += 0.03; if (B>1) B=0; 
	}
	lento = (lento+1)%10;


	glEnable(GL_BLEND);
	glBlendFunc(GL_ONE_MINUS_SRC_ALPHA, GL_SRC_ALPHA);
	glColor3f(R,G,B);

	glBegin(GL_QUADS);
	// Front Face
	glTexCoord2f(0.0f, 0.0f); glVertex3f(-2.5f, -1.5f,  1.0f);	// Bottom Left Of The Texture and Quad
	glTexCoord2f(1.0f, 0.0f); glVertex3f(-0.5f, -1.5f,  1.0f);	// Bottom Right Of The Texture and Quad
	glTexCoord2f(1.0f, 1.0f); glVertex3f(-0.5f,  0.5f,  1.0f);	// Top Right Of The Texture and Quad
	glTexCoord2f(0.0f, 1.0f); glVertex3f(-2.5f,  0.5f,  1.0f);	// Top Left Of The Texture and Quad
	glEnd();
	glDisable(GL_BLEND);
	glEnable(GL_DEPTH_TEST);
}

GLvoid DrawChicaDer(GLvoid)
{
	static int lento = 0;
	static int chicaD = 0;
	static float R  = 1;
	static float G  = 1;
	static float B  = 1;

	glLoadIdentity();								
	glTranslatef(0,0,-5.0f);
	glDisable(GL_DEPTH_TEST);

	glBindTexture(GL_TEXTURE_2D, texture[SIL5_TEXTURE-chicaD]);
	if (lento == 0){
		chicaD = (chicaD+1)%TAM_CHICA;
		R += 0.05; if (R>1) R=0;
		G += 0.15; if (G>1) G=0;
		B += 0.20; if (B>1) B=0; 
	}
	lento = (lento+1)%10;

	glEnable(GL_BLEND);
	glBlendFunc(GL_ONE_MINUS_SRC_ALPHA, GL_SRC_ALPHA);
	glColor3f(R, G, B);

	glBegin(GL_QUADS);
	// Front Face
	glTexCoord2f(0.0f, 0.0f); glVertex3f( 0.2f, -1.5f,  1.0f);	// Bottom Left Of The Texture and Quad
	glTexCoord2f(1.0f, 0.0f); glVertex3f( 2.2f, -1.5f,  1.0f);	// Bottom Right Of The Texture and Quad
	glTexCoord2f(1.0f, 1.0f); glVertex3f( 2.2f,  0.5f,  1.0f);	// Top Right Of The Texture and Quad
	glTexCoord2f(0.0f, 1.0f); glVertex3f( 0.2f,  0.5f,  1.0f);	// Top Left Of The Texture and Quad
	glEnd();
	glDisable(GL_BLEND);
	glEnable(GL_DEPTH_TEST);
}

GLvoid DrawLogo(GLvoid)
{

	glLoadIdentity();								
	glTranslatef(0,0,-5.0f);

	glDisable(GL_DEPTH_TEST);
	glBindTexture(GL_TEXTURE_2D, texture[LOGO_TEXTURE]);
	glBegin(GL_QUADS);
	// Front Face
	glTexCoord2f(0.0f, 0.0f); glVertex3f(-2.3f,-1.9f,  1.0f);	// Bottom Left Of The Texture and Quad
	glTexCoord2f(1.0f, 0.0f); glVertex3f( 2.3f,-1.9f,  1.0f);	// Bottom Right Of The Texture and Quad
	glTexCoord2f(1.0f, 1.0f); glVertex3f( 2.2f, 1.9f,  1.0f);	// Top Right Of The Texture and Quad
	glTexCoord2f(0.0f, 1.0f); glVertex3f(-2.2f, 1.9f,  1.0f);	// Top Left Of The Texture and Quad
	glEnd();
	glEnable(GL_DEPTH_TEST);
}

GLvoid DrawFin(GLvoid)
{
	static float rot =0.0f;
	glLoadIdentity();								
	glTranslatef(0,0,-5.0f);

	glDisable(GL_DEPTH_TEST);
	glBindTexture(GL_TEXTURE_2D, texture[FIN_TEXTURE]);
	glBegin(GL_QUADS);
	// Front Face
	glTexCoord2f(0.0f, 0.0f); glVertex3f(-2.2f,-1.7f,  1.0f);	// Bottom Left Of The Texture and Quad
	glTexCoord2f(1.0f, 0.0f); glVertex3f( 2.2f,-1.7f,  1.0f);	// Bottom Right Of The Texture and Quad
	glTexCoord2f(1.0f, 1.0f); glVertex3f( 2.2f, 1.5f,  1.0f);	// Top Right Of The Texture and Quad
	glTexCoord2f(0.0f, 1.0f); glVertex3f(-2.2f, 1.5f,  1.0f);	// Top Left Of The Texture and Quad
	glEnd();
	//////////////
	//////////////
	//////////////
	//////////////
	glEnable(GL_BLEND);

	glBlendFunc(GL_ONE_MINUS_SRC_ALPHA, GL_SRC_ALPHA);
	glBindTexture(GL_TEXTURE_2D, texture[EST_TEXTURE]);
	glColor3f(1,1,1);

	//glLoadIdentity();								
	//glTranslatef(0,0,-5.0f);
	rot += 15.5;
	glRotatef(rot,0,0,1);


	glBegin(GL_QUADS);
	// Front Face
	glTexCoord2f(0.0f, 0.0f); glVertex3f( 2.0f, 0.2f,  1.0f);	// Bottom Left Of The Texture and Quad
	glTexCoord2f(1.0f, 0.0f); glVertex3f( 1.0f, 0.2f,  1.0f);	// Bottom Right Of The Texture and Quad
	glTexCoord2f(1.0f, 1.0f); glVertex3f( 1.0f, 1.2f,  1.0f);	// Top Right Of The Texture and Quad
	glTexCoord2f(0.0f, 1.0f); glVertex3f( 2.0f, 1.2f,  1.0f);	// Top Left Of The Texture and Quad
	glEnd();
	glDisable(GL_BLEND);
	glEnable(GL_DEPTH_TEST);
}


GLvoid DrawGLScene(GLvoid)
{
	Uint32 t0 = 0;

	t0 = SDL_GetTicks();
	if (theend == FALSE){

		if (bluractive == FALSE)
			glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
		else{
			glClear(GL_DEPTH_BUFFER_BIT);
			glBlendFunc(GL_SRC_ALPHA,GL_ONE);	
			glEnable(GL_BLEND);	
		}

		glColor4f(1, 1, 1, 0.5f);
		DrawTunnel();
		glDisable(GL_BLEND);	

		if (quitlogo == TRUE)
		{
			glEnable(GL_BLEND);	
			glBlendFunc(GL_ONE, GL_ONE);
		}

		if (gogos== FALSE) DrawLogo();
		if (quitlogo == TRUE) glDisable(GL_BLEND);	


		if (gogos){
			DrawChicaIzq();
			DrawChicaDer();
		}

		if (flashnegro == TRUE){
			flashnegro = FALSE;
			glClearColor(0.0f, 0.0f, 0.0f, 0.0f);
			glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
		}
		if (flashblanco == TRUE){
			flashblanco = FALSE;
			glClearColor(1.0f, 1.0f, 1.0f, 0.0f);
			glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
			glClearColor(0.0f, 0.0f, 0.0f, 0.0f);
		}

	}
	else
	{
		//////////////////////////////////////
		//FINAL
		//////////////////////////////////////
		glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
		DrawFin();
	}
	while(SDL_GetTicks()-t0 < MAX_SPEED_TIME);
}
