#ifndef _DEMO_SNF_H_
#define _DEMO_SNF_H_

//#include <windows.h>
#include <SDL/SDL.h>
#include <stdio.h>
#include <math.h>
#include <GL/gl.h>
#include <GL/glu.h>

#define TRUE	1
#define FALSE	0


#define MAX_SPEED_TIME      30

#define BLOB_EFECT          0
#define FIRE_EFECT          1
#define TV_EFECT            2
#define XTRA_EFECT          3
#define BOX_TEXTURE         4
#define NS_TEXTURE          5
#define SIL1_TEXTURE        6
#define SIL2_TEXTURE        7
#define SIL3_TEXTURE        8
#define SIL4_TEXTURE        9
#define SIL5_TEXTURE        10
#define LOGO_TEXTURE        11
#define FIN_TEXTURE         12
#define EST_TEXTURE         13
#define MAX_TEXTURES        14

#define TAM_CHICA     (SIL5_TEXTURE-SIL1_TEXTURE)
///////////////////////////////////////////////////
// Estructuras necesarias
///////////////////////////////////////////////////
typedef struct
{
	int width;
	int height;
	unsigned char *data;
} TEXTURE_IMAGE;

typedef TEXTURE_IMAGE *P_TEXTURE_IMAGE;							

///////////////////////////////////////////////////
// Variables globales
///////////////////////////////////////////////////
//extern HDC			hDC;

extern GLuint texture[MAX_TEXTURES];
extern P_TEXTURE_IMAGE tex_data[MAX_TEXTURES];

extern int jump_to_hyperspace_enable;
extern int flashblanco;
extern int flashnegro;
extern int bluractive;
extern int quitlogo;
extern int gogos;
extern int theend;


///////////////////////////////////////////////////
// Musica y eventos
///////////////////////////////////////////////////
void initmusic();
void playmusic();
void closemusic();
void refreshevents();

///////////////////////////////////////////////////
// Efectos
///////////////////////////////////////////////////
void blob_initefect();
void blob_calcefect(P_TEXTURE_IMAGE p);
void fire_initefect();
void fire_calcefect(P_TEXTURE_IMAGE p);
void tv_initefect();
void tv_calcefect(P_TEXTURE_IMAGE p);
void xtra_initefect();
void xtra_calcefect(P_TEXTURE_IMAGE p);

///////////////////////////////////////////////////
// Funciones de texturas
///////////////////////////////////////////////////
P_TEXTURE_IMAGE AllocateTextureBuffer(int w, int h);
void DeallocateTexture( P_TEXTURE_IMAGE t );
void BuildTexture (P_TEXTURE_IMAGE tex, int num);
void InitNSTexture(P_TEXTURE_IMAGE tex);
void InitBoxTexture(P_TEXTURE_IMAGE tex);

void InitSil1Texture();

GLvoid ReSizeGLScene(GLsizei width, GLsizei height);

#endif /*_DEMO_6DOF_H_ */
